<?php
/*
Plugin Name: Tag Widget
Plugin URI: http://buffercode.com/tag-widget-wordpress-plugin/
Description: Easy way to display the number of post in that particular tag by selecting from admin dashboard widget.
Version: 1.1
Author: vinoth06
Author URI: http://buffercode.com/
License: GPLv2
*/

// Additing Action hook widgets_init
add_action( 'widgets_init', 'bc_tag_widget'); 

function bc_tag_widget() {
register_widget( 'bc_tag_widget_info' );
}

class bc_tag_widget_info extends WP_Widget {
function bc_tag_widget_info () {
		$this->WP_Widget('bc_tag_widget_info', 'Tag Widget','Select the tag to display');	}

public function form( $instance ) { 
if ( isset( $instance[ 'bc_tag_no_post' ]) && isset ($instance[ 'bc_tag_no_tag' ]) && isset ($instance[ 'bc_tag_name' ])  && isset ($instance[ 'bc_tag_bullet' ]) && isset ($instance[ 'bc_tag_title_count' ])) {
			$bc_tag_name_value = $instance[ 'bc_tag_name' ];
			$bc_tag_no_tag_value = $instance[ 'bc_tag_no_tag' ];
			$bc_tag_no_post_value = $instance[ 'bc_tag_no_post' ];
			$bc_tag_bullet_value = $instance[ 'bc_tag_bullet' ];
			$bc_tag_title_count_value = $instance[ 'bc_tag_title_count' ];
}
		else {
		$bc_tag_no_post_value = 5;
		$bc_tag_no_tag_value = 1;
		$bc_tag_value = 1;
		$bc_tag_name_value	= 'My tag';
		$bc_tag_bullet_value = 2;
		$bc_tag_title_count_value =20;
		} ?>
		<!-- Custom Name for Widget - Buffercode.com -->
		<p>Name: <input class="widefat" name="<?php echo $this->get_field_name( 'bc_tag_name' ); ?>" type="text" value="<?php echo esc_attr( $bc_tag_name_value );?>" /></p>
		
		<!-- Select Tag for Widget - Buffercode.com -->
		<p>Select tag: <select name="<?php echo $this->get_field_name('bc_tag_no_tag'); ?>" id="<?php echo $this->get_field_id('bc_tag_no_tag'); ?>" class="widefat">
		<?php $posttags = get_tags();  if ($posttags) { foreach($posttags as $tag) {
		echo '<option value="' . $tag->name . '" id="' . $tag->name . '"', $bc_tag_no_tag_value == $tag->name ? ' selected="selected"' : '', '>', $tag->name, '</option>';
		} }?></select></p>
		
		<!-- Number of Post to show for Widget - Buffercode.com -->
		<p>Number of Post:
		<select name="<?php echo $this->get_field_name('bc_tag_no_post'); ?>" id="<?php echo $this->get_field_id('bc_tag_no_post'); ?>" class="widefat">
		<?php
		$options = array('1' =>'1','2' =>'2','3' =>'3','4' =>'4','5' =>'5','6'=>'6','7'=>'7','8'=>'8','9'=>'9','10'=>'10');
		foreach ($options as $langu => $code) {
		echo '<option value="' . $code . '" id="' . $code . '"', $bc_tag_no_post_value == $code ? ' selected="selected"' : '', '>', $langu, '</option>';
		}?></select></p>
		
		<!-- Show/Hide bullet style for Widget - Buffercode.com -->
		<p>Show Bullet Style:
		<select name="<?php echo $this->get_field_name('bc_tag_bullet'); ?>" id="<?php echo $this->get_field_id('bc_tag_bullet'); ?>" class="widefat">
		<?php
		$bullet_options = array('yes' =>'1','no' =>'2');
		foreach ($bullet_options as $bullet_value => $bullet_code) {
		echo '<option value="' . $bullet_code . '" id="' . $bullet_code . '"', $bc_tag_bullet_value == $bullet_code ? ' selected="selected"' : '', '>', $bullet_value, '</option>';
		}?>	</select></p>
		
		<p>Title Length: <input class="widefat" name="<?php echo $this->get_field_name( 'bc_tag_title_count' ); ?>" type="text" value="<?php echo esc_attr( $bc_tag_title_count_value );?>" /></p>
		
<?php
}

function update($new_instance, $old_instance) {
$instance = $old_instance;
$instance['bc_tag_no_post'] = ( ! empty( $new_instance['bc_tag_no_post'] ) ) ? strip_tags( $new_instance['bc_tag_no_post'] ) : '';

$instance['bc_tag_no_tag'] = ( ! empty( $new_instance['bc_tag_no_tag'] ) ) ? strip_tags( $new_instance['bc_tag_no_tag'] ) : '';

$instance['bc_tag_name'] = ( ! empty( $new_instance['bc_tag_name'] ) ) ? strip_tags( $new_instance['bc_tag_name'] ) : '';

$instance['bc_tag_bullet'] = ( ! empty( $new_instance['bc_tag_bullet'] ) ) ? strip_tags( $new_instance['bc_tag_bullet'] ) : '';

$instance['bc_tag_title_count'] = ( ! empty( $new_instance['bc_tag_title_count'] ) ) ? strip_tags( $new_instance['bc_tag_title_count'] ) : '';
return $instance;
}

function widget($args, $instance) {
extract($args);
echo $before_widget;
$bc_tag_name_value = apply_filters( 'widget_title', $instance['bc_tag_name'] );
$bc_tag_value = empty( $instance['bc_tag_no_tag'] ) ? '&nbsp;' :
$instance['bc_tag_no_tag'];
$bc_tag_no_post_value = empty( $instance['bc_tag_no_post'] ) ? '&nbsp;' :
$instance['bc_tag_no_post'];
$bc_tag_bullet_value = empty( $instance['bc_tag_bullet'] ) ? '&nbsp;' :
$instance['bc_tag_bullet'];
$bc_tag_title_count_value = empty( $instance['bc_tag_title_count'] ) ? '&nbsp;' :
$instance['bc_tag_title_count'];
if ( !empty( $name ) ) { echo $before_title . $bc_tag_name_value .
$after_title; };

  $args=array(
      'tag' => $bc_tag_value,
      'showposts'=>$bc_tag_no_post_value,
      );
 
 $my_query = new WP_Query($args);
    if( $my_query->have_posts() ) {
            while ($my_query->have_posts()) : $my_query->the_post(); ?><!-- Buffercode.com Tag List Plugin -->
        <li <?php if($bc_tag_bullet_value==2){?> style="list-style-type:none;<?php } ?>">
		
		<a href="<?php the_permalink(); ?> rel="bookmark" title="Permanent Link to <?php the_title_attribute(); ?>"><?php $check_title=get_the_title(); $title_count=strlen($check_title);
		if ($title_count>$bc_tag_title_count_value){
		$substr_title=substr($check_title, 0, $bc_tag_title_count_value);
		echo $substr_title.'...';
		}else{echo $check_title;	}
		
		?></a>
		
		</li><!-- Buffercode.com Tag List Plugin -->
       <?php
      endwhile;
    } //if ($my_query)
  wp_reset_query();  // Restore global post data stomped by the_post().
 echo $after_widget;
} } ?>
